/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  FSTOPPERS
 *  Copyright (C) 2008 by FUJISOFT INCORPORATED, JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: prc_config.c,v 1.3 2008/05/26 09:04:12 myasuma Exp $
 */

/*
 *  ץå¸⥸塼Nios2ѡ
 */
#include "kernel_impl.h"
#include "check.h"
#include "task.h"
#include <sil.h>


/*
 *  CPUåե饰¸Τѿ
 */
volatile bool_t		lock_flag;		/* CPUåե饰ͤݻѿ */

/*
 * ߥϥɥ/ӥåȥޥơ֥
 */
nios2_fp int_handler_table[MAX_INT_NUM];

/*
 * CPU㳰ϥɥơ֥
 */
nios2_fp exc_handler_table[MAX_EXC_NUM]; 

/*
 * ߤΥͥȲΥ
 * ͥ뵯ưϥΩȤߤʤ1ǽ
 */
uint32_t interrupt_count = 1;

/*
 * Ƴߤγ׵ػߥե饰ξ
 */
uint32_t idf;

/*
 * ߤγͥ٥ޥ
 */
PRI ipm;
 
/*
 *  °ꤵƤ뤫Ƚ̤뤿ѿ
 */
uint32_t	bitpat_cfgint;

/*
 * ͥ٥ơ֥
 */
inh_ipm_tbl_t	inh_ipm_tbl[MAX_INT_NUM];

/*
 *  ͥ٥ޥ˥åȤ롤׵ػߥե饰
 *  Υơ֥
 */
uint32_t ipm_mask_tbl[IPM_MASK_TBL_MAX];


/*
 *  ץå¸ν
 */
void
prc_initialize()
{
    int i, j;
    
    /*
     * int_handler_table[],int_plevel_table[]ν
     * ̤Ͽγȯcpu_interrup()ƤӽФ褦
     * no_reg_interrup()Ͽ
     */
    for(i = 0; i < MAX_INT_NUM; i++){
        int_handler_table[i] = no_reg_interrupt;
    }

    /*
     *  CPU㳰ϥɥơ֥
     */
    for(i = 0; i < MAX_EXC_NUM; i++){
        exc_handler_table[i] = no_reg_exception; 
    }

    /*
     *  CPUåե饰¸Τѿν
     */
    lock_flag = true;

    /*
     * Ƴߤγ׵ػߥե饰ػ
     */
    idf = ~0U;

    /*
     * ͥ٥ޥ0
     */ 
    ipm = 0U;

    /*
     *  °ꤵƤ뤫Ƚ̤뤿ѿ롥
     */
    bitpat_cfgint = 0U;
    
    /*
     *  ͥ٥ơ֥
     */
    for (i = 0; i < MAX_INT_NUM; i++) {
		inh_ipm_tbl[i].num = 0;
		for (j = 0; j < MAX_INT_NUM; j++) {
			inh_ipm_tbl[i].intno[j] = 0;
		}
	}

    /*
     *  ͥ٥ޥơ֥
     */
    for (i = 0; i < IPM_MASK_TBL_MAX; i++) {
		ipm_mask_tbl[i] = 0U;
	}
	ipm_mask_tbl[0] = 0xffffffff;	/* ͥ٥ޥ0All'F */

}

/*
 *  ץå¸νλ
 *  ߶ػ
 */
void
prc_terminate()
{
    disint();
}


/*
 * ̤Ͽγߤȯ˸ƤӽФ
 */
void
no_reg_interrupt(void)
{
    syslog(LOG_EMERG, "Unregisted Interrupt Occur!");
    while(1);
}

/*
 * ̤Ͽ㳰ȯ˸ƤӽФ
 * (桼CPU㳰ϥɥ餬ϿʤΥǥեȥϥɥ)
 *
 * ܥϥɥ餬ưȰʲνԤ
 *  ɽ
 *  ̵¥롼 (̤̿ᡢʤӤˤ¾Υ顼ξ)
 *
 * [ɽ]
 *  㳰ȯɥ쥹
 *  㳰Ȥʤäޥ̿
 *
 * []
 *  p_excinfϡ㳰ȯΥ쥸򥻡֤åɥ쥹
 *  åɥ쥹Ƭ72byte(18word)ΰ֤㳰ȯ
 *  ץꥢɥ쥹(ea쥸)ǼƤ롥
 *  äơꥢɥ쥹-4byte(-1word)սפС
 *  㳰ȯ̿򻲾Ȥ뤳ȤǤ롥
 *
 *  ܥϥɥؿưϰʲ̤ꡥ
 *  եȥȥåסtrap̿)
 *  ̤̿mul, muli, mulxss, mulxsu, mulxuu, div, divu̿)
 *  ¾ NiosIIξεǽɲäˤ㳰 (MMUܤʤ)
 *
 *  ޤܴؿϥѿѰդʤƤ¸ǽ
 *  βͥ褷ѿѤ뤳Ȥ
 *
 */
void
no_reg_exception(VP p_excinf)
{
	uint8_t*		stack_addr;					/* åɥ쥹 */
	uint32_t		exc_addr;					/* 㳰ɥ쥹     */
	uint32_t		exc_instruction;			/* 㳰̿         */
	bool_t			instruction_trap = false;	/* ̿         */
	uint32_t		log_level = LOG_EMERG;		/* ٥       */
	
	
	/* ѿѰդʤƤ¸ǽθ */
	stack_addr = (char*)p_excinf;
	exc_addr = *((int*)&stack_addr[72]) - 4;
	exc_instruction = *((int*)(*((int*)&stack_addr[72]) - 4));
	
	/* trap̿ᡩ */
	if (exc_instruction == 0x003b683a) {
		/* trap̿ */
		instruction_trap = true;
		/* trapϡLOG_ALERTץ٥Ȥ */
		log_level = LOG_ALERT;
 	}
	
    syslog(log_level, "*** Occurred CPU Exception (default exception handler) ***");
    /* 㳰ȯɥ쥹 (ꥢɥ쥹 - 4)*/
    syslog(log_level, " address    : 0x%08x", exc_addr);
    /* 㳰ȯ̿ (ꥢɥ쥹 - 4 ̿) */
    syslog(log_level, " instruction: 0x%08x", exc_instruction);
    
    /* trap̿ʳ̵¥롼פˤ */
    if (instruction_trap) {
        syslog(log_level, " type       : trap\n");
    } else {
        syslog(log_level, " type       : unimplemented instructions or other\n");
		while(1);    
	}
}

/*
 * װȽȳߥϥɥθƤӽФ
 *
 * ͥ٥ޥꤷ塢ߥϥɥ¹ԡ
 * ߥϥɥλ塢γͥ٥ޥ᤹
 *
 */
void
int_handler_call(){
    uint32_t status;
    int      i, j;
    PRI      previous_ipm = 0;		/* ߥϥɥ¹IPM  */
    uint32_t intno;					/* IRQֹ */
    uint8_t  find_flag = 0;			/* дλե饰 */

    /* ߥ󥿤û */
    interrupt_count++;
    /* ߥڥǥ󥰾ɤ߽Ф */
    status = current_ipending();

	/* ͥٽIRQߤ򥵡 */
    for(i = (MAX_INT_NUM - 1); i >= 0; i--){
		/* Ʊͥ٤IRQߤ򥵡 */
		for (j = 0; j < inh_ipm_tbl[i].num; j++) {
			intno = inh_ipm_tbl[i].intno[j];
			if (!(status & (1 << intno))) continue;
			find_flag = 1;					/* ߤȯIRQ򸡽 */
            previous_ipm = i_get_ipm();		/* ϥɥ¹IPMͤ¸ */
			i_set_ipm(INDEX_IPM(i + 1));	/* ͥ٤ */
            
            enaint();						/* ߶ػ߲ */
            (int_handler_table[intno])();	/* ߥϥɥ¹ */
            disint();						/* ߶ػ */

            i_set_ipm(previous_ipm);		/* ϥɥ¹IPM᤹ͤ */
            break;
        }
        /* ߤȯIRQ򸡽ФʤХ롼æ */
        if (find_flag == 1) break;
    }
    /* ߥ󥿤򸺻 */
    interrupt_count--;    
}

/*
 *  㳰ȽCPU㳰ϥɥθƤӽФ
 *
 *  1 r4
 *  2 r5
 *
 */
void
exc_handler_call(VP p_excinf, uint32_t exc_no)
{
	/* 㳰ֹΥå */
	if (!(exc_no < 2)) {
		/* ̾Ϥꤨʤ롼 */
		return;
	} 
    interrupt_count++;

	/* CPUå֤Υå */
	if (i_sense_lock() == false) {
		/* CPUå֤ǤϤʤΤǡϡɥߤĤ */
		enaint();
	}

	/* CPU㳰ϥɥ顦 */
    (exc_handler_table[exc_no])(p_excinf);

    if (i_sense_lock() == false) {
		/* ϡɥ߶ػ */
		disint();
	}
    
    interrupt_count--;    
}

#ifdef SUPPORT_XLOG_SYS

void
xlog_sys(void* p_excinf)
{

}

#endif /* SUPPORT_XLOG_SYS */
