/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  FSTOPPERS
 *  Copyright (C) 2008 by FUJISOFT INCORPORATED, JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: prc_insn.h,v 1.2 2008/05/26 09:04:12 myasuma Exp $
 */

/*
 *		ץåü̿Υ饤ؿNiosIIѡ
 */

#ifndef	TOPPERS_PRC_INSN_H
#define	TOPPERS_PRC_INSN_H


/*
 *  ߥӥå
 */
#define STATUS_U   0x02
#define STATUS_PIE 0x01

Inline uint32_t
current_status(void)
{
    uint32_t status;
    Asm("rdctl %0, status" : "=r" (status));
    return(status);
}

Inline uint32_t
current_estatus(void)
{
    uint32_t status;
    Asm("rdctl %0, estatus" : "=r" (status));
    return(status);
}

Inline uint32_t
current_bstatus(void)
{
    uint32_t status;
    Asm("rdctl %0, bstatus" : "=r" (status));
    return(status);
}

Inline uint32_t
current_ipending(void)
{
    uint32_t status;
    Asm("rdctl %0, ipending" : "=r" (status));
    return(status);
}

Inline uint32_t
current_ienable(void)
{
    uint32_t status;
    Asm("rdctl %0, ienable" : "=r" (status));
    return(status);
}

Inline void
set_status(uint32_t status)
{
    Asm("wrctl status, %0" :: "r" (status));
}

Inline void
set_ienable(uint32_t ienable)
{
    Asm("wrctl ienable, %0" :: "r" (ienable));
}

Inline void
disint(void)
{
    set_status(current_status() & ~STATUS_PIE);
}

Inline void
enaint(void)
{
    set_status(current_status() | STATUS_PIE);    
}

Inline void
enairq(uint32_t intno){
    set_ienable((1 << intno) | current_ienable()); 
}

Inline void
disirq(uint32_t intno){
    set_ienable(~(1 << intno) & current_ienable());    
}

#endif /* TOPPERS_PRC_INSN_H */
