/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  FSTOPPERS
 *  Copyright (C) 2008 by FUJISOFT INCORPORATED, JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: prc_support.S,v 1.2 2008/05/26 09:04:13 myasuma Exp $
 */

/*
 *		ץå¸⥸塼 ֥NiosIIѡ
 */

#define TOPPERS_MACRO_ONLY
#define TOPPERS_ASM_MACRO

/*
 *  åȰ¸
 */
#include "kernel_impl.h"
#include "offset.h"

    .set noat
    .section .exceptions, "xa"
    .align 2
    .global _irq_entry
    .type   _irq_entry, @function
_irq_entry:
    /*
     *  㳰װȽ
     */
    rdctl   et, estatus
    andi    et, et, 1
    beq     et, zero, _check_trap_or_exc
    rdctl   et, ipending
    beq     et, zero, _check_trap_or_exc


   /*
    * 㳰װϳ
    */
    addi ea, ea, -4      /* Ϥǥ */

    addi  sp, sp, -80    /* 㳰Ƚи碌뤿ᡢ;ʬ˳ */
    rdctl et, estatus    /* 쥸¸ */
    stw   et,   0(sp)
    stw   at,   4(sp)
    stw   r2,   8(sp)
    stw   r3,  12(sp)
    stw   r4,  16(sp)
    stw   r5,  20(sp)
    stw   r6,  24(sp)
    stw   r7,  28(sp)
    stw   r8,  32(sp)
    stw   r9,  36(sp)
    stw   r10, 40(sp)
    stw   r11, 44(sp)
    stw   r12, 48(sp)
    stw   r13, 52(sp)
    stw   r14, 56(sp)
    stw   r15, 60(sp)
    stw   fp,  64(sp)
    stw   ra,  68(sp)
    stw   ea,  72(sp)

    ldw   r3,  %gprel(ipm)(gp)	     /* 㳰Ѥipmͤ򥹥å¸ */
	stw   r3,  76(sp)

    /*
     * ¿ųߤȽ
     */
    ldw   r3, %gprel(interrupt_count)(gp)  /* ͥȲΥå */
    bltu  zero, r3,  nest_int              /* ¿ųߤʤСnest_int٥ */

    ldw   r2, %gprel(_kernel_istkpt)(gp)   /* ߥåѹ */
	addi  r2, r2, -4                       /* åݥ󥿤¸뤿ξ */
    stw   sp, 0(r2)                        /* åݥ󥿤¸ */        
    mov   sp, r2                           /* åݥ󥿤ؤ */

nest_int:
    addi  sp, sp, -4                 /* CPUå֤ߥå¸ */
    ldw   r3,  %gprel(lock_flag)(gp) /* (㳰Ƚи碌뤿)  */
    stw   r3,  0(sp)                 /* ret_from_int롼Ǹ᤹      */

    /*
     *  װȽȸƤӽФ
     */
    call int_handler_call

ret_from_int:
	/*
     * 6.6.1 ߥϥɥν
     *
     * 󥿥ƥȤǳȯξϡ
     * å쥸򥹥å
     * ߽Υ꥿
	 */
    ldw   r3, 0(sp)                 /* CPUå֤򸵤᤹ */
    stw   r3, %gprel(lock_flag)(gp)
    addi  sp, sp, 4                 /* åݥĴ    */

    ldw   r3, %gprel(interrupt_count)(gp)
    bltu  zero, r3, res_reg_and_ret /* ͥȲ1ʾʤ */

    ldw   r2, 0(sp)                 /* åݥ󥿤᤹    */
    mov   sp, r2                    /* åݥ󥿤᤹    */

	/*
     * reqflgʤСå쥸򥹥å
     * ߽Υ꥿
	 */
    ldw   r3, %gprel(reqflg)(gp)    /* reqflgΥå */
    beq   r3, zero, res_reg_and_ret
    br    ret_int

res_reg_and_ret:
    ldw   et,   0(sp)               /* 쥸 */
    wrctl estatus, et
    ldw   at,   4(sp)
    ldw   r2,   8(sp)
    ldw   r3,  12(sp)
    ldw   r4,  16(sp)
    ldw   r5,  20(sp)
    ldw   r6,  24(sp)
    ldw   r7,  28(sp)
    ldw   r8,  32(sp)
    ldw   r9,  36(sp)
    ldw   r10, 40(sp)
    ldw   r11, 44(sp)
    ldw   r12, 48(sp)
    ldw   r13, 52(sp)
    ldw   r14, 56(sp)
    ldw   r15, 60(sp)
    ldw   fp,  64(sp)
    ldw   ra,  68(sp)
    ldw   ea,  72(sp)
    addi  sp, sp, 80
    eret

_check_trap_or_exc:
    addi  sp, sp, -80
    rdctl et,   estatus
    stw   et,    0(sp)
    stw   at,    4(sp)
    stw   r2,    8(sp)
    stw   r3,   12(sp)
    stw   r4,   16(sp)
    stw   r5,   20(sp)
    stw   r6,   24(sp)
    stw   r7,   28(sp)
    stw   r8,   32(sp)
    stw   r9,   36(sp)
    stw   r10,  40(sp)
    stw   r11,  44(sp)
    stw   r12,  48(sp)
    stw   r13,  52(sp)
    stw   r14,  56(sp)
    stw   r15,  60(sp)
    stw   fp,   64(sp)
    stw   ra,   68(sp)
    stw   ea,   72(sp)

    ldw   r3,   %gprel(ipm)(gp)	 /* 㳰Ѥipmͤ򥹥å¸ */
	stw   r3,   76(sp)

    /*
     *  TrapȽ
     */
    movi  r5, 0           /* ͤȤơ֥եȥȥåספ */
    ldw   et, -4(ea)      /* 㳰Ф̿ */
    xorhi et, et, 0x003b  /*  16bit             */
    xori  et, et, 0x683a  /*  16bit             */
    beq   et, zero, set_exc_handler_info
    movi  r5, 1           /* ̤̿᡿¾פ */

    /*
     *  CPU㳰ϥɥ鶦̽
     */
set_exc_handler_info:

    mov   r4,   sp     /* ϥɥΰ */

    /*
     * ¿ųߤȽ
     */
    ldw   r3, %gprel(interrupt_count)(gp)  /* ͥȲΥå */
    bltu  zero, r3,  nest_int_exc          /* ¿ųߤʤСnest_int_exc٥ */
    
    ldw   r2, %gprel(_kernel_istkpt)(gp)   /* ߥåѹ */
    addi  r2, r2, -4                       /* åݥ󥿤¸뤿ξ */
    stw   sp, 0(r2)                        /* åݥ󥿤¸     */
    mov   sp, r2                           /* åݥ󥿤ؤ */

nest_int_exc:
    addi  sp, sp, -4                 /* CPUå֤ߥå¸ */
    ldw   r3,  %gprel(lock_flag)(gp) /* ret_from_int롼Ǹ᤹      */
    stw   r3,  0(sp)

    call exc_handler_call  /* CPU㳰ϥɥƤӽФ롼μ¹ */
                           /* 1 r4 2 r5 */
    br ret_from_int        /* ꥿ */



    .set noat
    .align  2
    .global ret_int
    .global ret_exc
ret_int:
ret_exc:
	/* 6.6.1 ߥϥɥν */
    stw   zero, %gprel(reqflg)(gp)	   /* reqflg = false; */
    wrctl status, zero	               /* CPUå֤ˤ (ߤζػ) */
    movi  r5, 1                        /* CPUåå֤        */
    stw   r5, %gprel(lock_flag)(gp)
	
    ldw   r6,   %gprel(dspflg)(gp)     /* r6 <- dspflg                      */
    ldw   r5,   %gprel(p_runtsk)(gp)   /* r5 <- p_runtsk                    */
    ldw   r4,   %gprel(p_schedtsk)(gp) /* r4 <- p_schedtsk                  */

	/* (dspflg && p_runtsk != p_schedtsk)Ƚ */
    beq   r6,   zero, ret_int_1        /* dspflg   == false    -> ret_int_1 */
    beq   r4,   r5, ret_int_1          /* p_runtsk == schedtsk -> ret_int_1 */

	/* (dspflg && p_runtsk != p_schedtsk)ξ */
    addi  sp,   sp, -32                /* ĤΥ쥸¸              */
    stw   r16,  0(sp)
    stw   r17,  4(sp)
    stw   r18,  8(sp)
    stw   r19, 12(sp)
    stw   r20, 16(sp)
    stw   r21, 20(sp)
    stw   r22, 24(sp)
    stw   r23, 28(sp)
    stw   sp,  TCB_sp(r5)              /* åTCB¸     */
    movhi r2,  %hiadj(ret_int_r)       /* ret_int_r¹ԳϤȤ */
    addi  r2,  r2, %lo(ret_int_r)
    stw   r2,  TCB_pc(r5)              /* ¹ԺƳϤTCB¸       */
    br    dispatcher

ret_int_r:
    ldw   r16,  0(sp)                  /* 쥸 */
    ldw   r17,  4(sp)
    ldw   r18,  8(sp)
    ldw   r19, 12(sp)
    ldw   r20, 16(sp)
    ldw   r21, 20(sp)
    ldw   r22, 24(sp)
    ldw   r23, 28(sp)
    addi  sp, sp, 32

ret_int_1:
    /*
     *  㳰롼εư    
     *  ret_int_r  dispatcher ƤӽФ뤿ᡤ
     *  tcbΥɥ쥹 r4 äƤ
     */
    ldbu r5, TCB_enatex(r4)            /* r5 <- enatex */
    andi r6, r5, TCB_enatex_mask
    beq  r6, zero, ret_int_2           /* enatex  false ʤ꥿      */
    ldw  r7, TCB_texptn(r4)            /* r7 <- texptn, texptn0Ǥʤ */
    beq  zero, r7, ret_int_2
    call call_texrtn                   /* 㳰롼θƤӽФ      */

ret_int_2:
    stw   zero, %gprel(lock_flag)(gp)  /* CPUåå */
    ldw   et,   0(sp)                  /* 쥸 */
    wrctl estatus, et
    ldw   at,   4(sp)
    ldw   r2,   8(sp)
    ldw   r3,  12(sp)
    ldw   r4,  16(sp)
    ldw   r5,  20(sp)
    ldw   r6,  24(sp)
    ldw   r7,  28(sp)
    ldw   r8,  32(sp)
    ldw   r9,  36(sp)
    ldw   r10, 40(sp)
    ldw   r11, 44(sp)
    ldw   r12, 48(sp)
    ldw   r13, 52(sp)
    ldw   r14, 56(sp)
    ldw   r15, 60(sp)
    ldw   fp,  64(sp)
    ldw   ra,  68(sp)
    ldw   ea,  72(sp)
    addi  sp, sp, 80
    eret




    .global dispatch
    .align  2
dispatch:                            /* (6-5-3-1)      */
    addi  sp, sp, -40                /* 쥸¸ */
    stw   r16,  0(sp)
    stw   r17,  4(sp)
    stw   r18,  8(sp)
    stw   r19, 12(sp)
    stw   r20, 16(sp)
    stw   r21, 20(sp)
    stw   r22, 24(sp)
    stw   r23, 28(sp)
    stw   fp,  32(sp)
    stw   ra,  36(sp)
    ldw   r4,  %gprel(p_runtsk)(gp)  /* r4 <- p_runtsk            */
    stw   sp,  TCB_sp(r4)            /* åTCB¸ */
    movhi r5,  %hiadj(dispatch_r)    /* ¹ԳϤ¸        */
    addi  r5,  r5, %lo(dispatch_r)
    stw   r5,  TCB_pc(r4)            /* ¹ԺƳϤTCB¸   */
    br    dispatcher

dispatch_r:
    ldw   r16,  0(sp)                /* 쥸 */
    ldw   r17,  4(sp)
    ldw   r18,  8(sp)
    ldw   r19, 12(sp)
    ldw   r20, 16(sp)
    ldw   r21, 20(sp)
    ldw   r22, 24(sp)
    ldw   r23, 28(sp)
    ldw   fp,  32(sp)     
    /*
     * 㳰롼εư
     *  dispatch_r  dispatcher ƤӽФ뤿ᡤ
     *  tcb Υɥ쥹 r4 äƤ
     */    
    ldbu r5, TCB_enatex(r4)          /* r5 <- enatex */
    andi r6, r5, TCB_enatex_mask
    beq  r6, zero, dispatch_r_1      /* enatex  false ʤ꥿ */
    ldw  r7, TCB_texptn(r4)          /* r7 <- texptn, texptn0Ǥʤ */
    beq  r7, zero, dispatch_r_1
    call call_texrtn                 /* 㳰롼θƤӽФ */

dispatch_r_1:
    ldw   ra, 36(sp)                 /* ĤΥ쥸 */
    addi  sp, sp, 40
    ret


/*
 *  ǥѥåưϡprc_support.S
 */
	.globl start_dispatch
start_dispatch:
	/*
     *   6.5.4 ǥѥåư
     *
     *  ǥѥåưϡstart_dispatchˤϡͥ뵯ưˡ
     *  νƤӽФ롥start_dispatchϡ꥿󤹤뤳ȤΤ
     *  ؿǤ롥
     *
     *  start_dispatchϡ󥿥ƥȤǡNMI٤Ƥγߤޥ
     *  ֡ߥå֤Ʊξ֡ˤǸƤӽФ롥start_dispatch
     *  ǡƥȤڤ괹CPUå֡ͥ٥ޥ
     *  ֤ˤʤФʤʤ
	 */


    .global exit_and_dispatch
exit_and_dispatch:
	/*
     *  6.5.5 ߤΥƥȤΤƤƥǥѥå
     *
     *  ߤΥƥȤΤƤƥǥѥåexit_and_dispatchˤϡ
     *  λ륵ӥؿƤӽФ롥exit_and_dispatchϡ
     *  ꥿󤹤뤳ȤΤʤؿǤ롥
     *
     *  exit_and_dispatchϡƥȡCPUå֡ǥѥå
     *  ľ֡ͥ٥ޥ֤ǸƤӽФ롥
     *
     */
    stw   zero, %gprel(interrupt_count)(gp) /* interrupt_count 򥯥ꥢ */

dispatcher:
    /*  6.5.2 ǥѥå
     *
     *  ǥѥåΡdispatcherˤϡå¸ľܸƤӽФ
     *  뤳ȤϤʤͥΥåȰ¸Τ߸ƤӽФ롥
     *  dispatcherϡƥȡCPUå֡ǥѥåľ֡
     *  ͥ٥ޥ֤ǸƤӽФ롥
     *
     */
    ldw   r4,   %gprel(p_schedtsk)(gp)      /* r4 <- p_schedtsk            */
    stw   r4,   %gprel(p_runtsk)(gp)        /* p_schedtsk  p_runtsk    */
    beq   r4,   zero, dispatcher_1          /* p_schedtsk뤫          */
    ldw   sp,   TCB_sp(r4)                  /* TCB饿å */
    ldw   r5,   TCB_pc(r4)                  /* TCB¹ԺƳϤ   */
    jmp   r5

dispatcher_1:
    /*
     * ǳߥ⡼ɤڤؤΤϡȯ߽
     * ˤɤΥåȤȤβȡߥϥɥ
     * ΥǥѥåɻߤȤ2Ĥΰ̣롥
     */
    ldw   sp, %gprel(_kernel_istkpt)(gp)    /* ߥåѹ */
    movi  r5, 1                             /* interrupt_count 1 */
    stw   r5, %gprel(interrupt_count)(gp)

dispatcher_2:
    stw   zero, %gprel(lock_flag)(gp)       /* CPUå֤ */
    wrctl status, r5                        /* ߤε */
    nop
    nop
    nop
    nop
    wrctl status, zero                      /* ߤζػ             */
    movi  r6, 1                             /* CPUåå֤  */
    stw   r6, %gprel(lock_flag)(gp)
    ldw   r6, %gprel(reqflg)(gp)            /* r6 <- reqflg             */
    beq   r6, zero, dispatcher_2            /* reqflg  false ʤ     */
    stw   zero, %gprel(interrupt_count)(gp) /* interrupt_count 򥯥ꥢ */
    stw   zero, %gprel(reqflg)(gp)          /* reqflg  false        */
    br    dispatcher


/*
 * ͥνλθƽФ
 *
 * 󥿥ƥȤڤ괹ơexit_kernelʬؿext_ker
 * ƤӽФ롥exit_kernelϥ꥿󤹤뤳Ȥʤᡤδؿ
 * äƤ뤳ȤϹͤɬפʤ
 */
	.globl call_exit_kernel
call_exit_kernel:							/* (6-8-3) */
    ldw   sp, %gprel(_kernel_istkpt)(gp)    /* ߥåѹ */
	call  exit_kernel                       /* exit_kernel()μ¹  */


    .text
    .global start_r
    .align 2
/*
 *  ϻ
 *
 *  dispatcherƤӽФ.TCBΥɥ쥹r4äƤ.
 */
start_r:
	stw   zero, %gprel(lock_flag)(gp)       /* CPUå֤      */
    movi  r2, 1
    wrctl status, r2      		            /* ߵ               */
	ldw   r3, TCB_p_tinib(r4)	            /* p_runtsk->p_tinibr3  */
    ldw   r4, TINIB_exinf(r3)	            /* (exinf)              */
    ldw   r2, TINIB_task(r3)	            /* μ¹         */
    movhi ra, %hiadj(ext_tsk)
    addi  ra, ra, %lo(ext_tsk)	            /*              */
    jmp   r2					            /* μ¹Գ         */


    .globl software_term_hook
software_term_hook:
	ret


    .globl _hardware_init_hook
_hardware_init_hook:
	ret


    .globl _software_init_hook
_software_init_hook:
	ret


/*
 *  Ԥ (4-2-1)
 *   r4: input parameter (delay time)
 */
    .globl _sil_dly_nse
_sil_dly_nse:
	subi	r3, r4, SIL_DLY_TIM1		/* ͤSIL_DLY_TIM1ʬ       */
	bgt		r3, zero, _sil_dly_nse1		/* ̤0ʾʤ_sil_dly_nse1٥ */
	ret									/* ̤0ʲʤλ              */
_sil_dly_nse1:
	subi	r3, r3, SIL_DLY_TIM2		/* SIL_DLY_TIM2ʬ                 */
	bgt		r3, zero, _sil_dly_nse1		/* ̤0ʾʤ_sil_dly_nse1٥ */
	ret									/* ̤0ʲʤλ              */
