/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005,2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  FSTOPPERS
 *  Copyright (C) 2008 by FUJISOFT INCORPORATED, JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: fsmpb.h,v 1.2 2008/05/26 09:06:18 myasuma Exp $
 */


/*
 *		FSMPB for NiosIIΥϡɥ񸻤
 */

#ifndef TOPPERS_FSMPB_H
#define TOPPERS_FSMPB_H

#include <sil.h>

#ifndef TOPPERS_MACRO_ONLY
#include <itron.h>
#endif /* TOPPERS_MACRO_ONLY */

#ifdef NIOS2_HAL
#include "system.h"
#endif /* NIOS2_HAL */

#define ALTERA_DEV


#ifdef NIOS2_HAL


/*
 *  TIM ߤγֹ
 */
#define TIM_INTLVL        SYS_CLK_TIMER_IRQ


/*
 * UART ߤγֹ
 */
#ifndef USE_JTAG_UART
#define UART_INTLVL       UART_IRQ
#else
#define UART_INTLVL       JTAG_UART_IRQ
#endif /* USE_JTAG_UART */


/*                                                                             
 *  ꥢݡֹ˴ؤ      
 */
#define TNUM_PORT   1   /* ݡȤ륷ꥢݡȤο */
#define TNUM_SIOP   1   /* ݡȤ륷ꥢI/OݡȤο */

/*
 *  ƥॿ˴ؤ
 */
#define LOGTASK_PORTID    1    /* ƥϤ륷ꥢݡֹ */


/*
 * ROMξΡROM(FLASH)RAM
 */ 
#define ROM_BASE   FLASH_MEMORY_BASE
#define RAM_BASE   DDR_SDRAM_BASE

#ifndef TOPPERS_MACRO_ONLY
#endif /* TOPPERS_MACRO_ONLY */

#ifndef TOPPERS_MACRO_ONLY
#ifdef TOPPERS_GDB_STUB				/* GDB */
#else /* TOPPERS_GDB_STUB */		/* ¾γȯĶ */
#endif /* TOPPERS_GDB_STUB */
#endif /* TOPPERS_MACRO_ONLY */


#else  /* NIOS2_HAL */


/*
 * ڥեΥ١ɥ쥹
 */
#define PERI_BASE 0x01000000

/*
 *  TIMER Υ١ɥ쥹
 */
#define TIM_BASE (PERI_BASE + 0x003190A0u)

/*
 *  TIM ߤγֹ
 */
#define TIM_INTLVL        1


/*
 * UART ߤγֹ
 */
#ifndef USE_JTAG_UART
#define UART_INTLVL       16
#else
#define UART_INTLVL       4
#endif /* USE_JTAG_UART */


/*                                                                             
 *  ꥢݡֹ˴ؤ      
 */
#define TNUM_PORT   1   /* ݡȤ륷ꥢݡȤο */
#define TNUM_SIOP   1   /* ݡȤ륷ꥢI/OݡȤο */


#ifndef USE_JTAG_UART
#define UART_BASE  (PERI_BASE + 0x00010840)
#else
#define UART_BASE  (PERI_BASE + 0x003191F8)
#endif /* USE_JTAG_UART */


/*
 *  Timer
 *  Full-featuredݡ 
 */

/*
 * եå
 */
#define TIM_STATUS_OFFSET  0x00
#define TIM_CONTROL_OFFSET 0x04
#define TIM_PERIODL_OFFSET 0x08
#define TIM_PERIODH_OFFSET 0x0C
#define TIM_SNAPL_OFFSET 0x10
#define TIM_SNAPH_OFFSET 0x14

#define TIM_STATUS_RUN 0x02
#define TIM_STATUS_TO  0x01

#define TIM_CONTROL_STOP  0x08
#define TIM_CONTROL_START 0x04
#define TIM_CONTROL_COUNT 0x02
#define TIM_CONTROL_ITO   0x01

/*
 *
 */
#define TIM_STATUS  (TIM_BASE + TIM_STATUS_OFFSET)
#define TIM_CONTROL (TIM_BASE + TIM_CONTROL_OFFSET)
#define TIM_PERIODL (TIM_BASE + TIM_PERIODL_OFFSET)
#define TIM_PERIODH (TIM_BASE + TIM_PERIODH_OFFSET)
#define TIM_SNAPL   (TIM_BASE + TIM_SNAPL_OFFSET)
#define TIM_SNAPH   (TIM_BASE + TIM_SNAPH_OFFSET)


/*
 * UART
 */
#define UART_RXDATA_OFFSET  0x00
#define UART_TXDATA_OFFSET  0x04
#define UART_STATUS_OFFSET  0x08
#define UART_CONTROL_OFFSET 0x0C
#define UART_DIVISOR_OFFSET 0x10
#define UART_ENDOFPACKET_OFFSET 0x1C

#define UART_STATUS_EOP   0x1000
#define UART_STATUS_CTS   0x0800
#define UART_STATUS_DCTS  0x0400
#define UART_STATUS_E     0x0100
#define UART_STATUS_RRDY  0x0080
#define UART_STATUS_TRDY  0x0040
#define UART_STATUS_TMT   0x0020
#define UART_STATUS_TOE   0x0010
#define UART_STATUS_ROE   0x0008
#define UART_STATUS_BRK   0x0004
#define UART_STATUS_FE    0x0002
#define UART_STATUS_PE    0x0001

#define UART_CONTROL_IEOP  0x1000
#define UART_CONTROL_RTS   0x0800
#define UART_CONTROL_IDCTS 0x0400
#define UART_CONTROL_TRDK  0x0200
#define UART_CONTROL_IE    0x0100
#define UART_CONTROL_IRRDY 0x0080
#define UART_CONTROL_ITRD  0x0040
#define UART_CONTROL_ITMT  0x0020
#define UART_CONTROL_ITOE  0x0010
#define UART_CONTROL_IROE  0x0008
#define UART_CONTROL_IBRK  0x0004
#define UART_CONTROL_IFE   0x0002
#define UART_CONTROL_IPE   0x0001

#define UART_RXDATA  (UART_BASE + UART_RXDATA_OFFSET)
#define UART_TXDATA  (UART_BASE + UART_TXDATA_OFFSET)
#define UART_STATUS  (UART_BASE + UART_STATUS_OFFSET)
#define UART_CONTROL (UART_BASE + UART_CONTROL_OFFSET)
#define UART_DIVISOR (UART_BASE + UART_DIVISOR_OFFSET)
#define UART_ENDOFPACKET (UART_BASE + UART_ENDOFPACKET_OFFSET)


/*
 * JTAG UARTϢ
 */ 
#define JTAG_UART_DATA_OFFSET    0x00
#define JTAG_UART_CONTROL_OFFSET 0x04

#define JTAG_UART_DATA_RVALID 0x8000

#define JTAG_UART_CONTROL_RIE 0x01
#define JTAG_UART_CONTROL_WIE 0x02
#define JTAG_UART_CONTROL_RIP 0x04
#define JTAG_UART_CONTROL_WIP 0x08
#define JTAG_UART_CONTROL_WSAPCE 0x0ffff0000

#define JTAG_UART_DATA    (UART_BASE + JTAG_UART_DATA_OFFSET)
#define JTAG_UART_CONTROL (UART_BASE + JTAG_UART_CONTROL_OFFSET)


/*
 *  ƥॿ˴ؤ
 */
#define LOGTASK_PORTID    1    /* ƥϤ륷ꥢݡֹ */

/*
 * å
 */ 
#define NIOS2_ICACHE_SIZE 4096
#define NIOS2_DCACHE_SIZE 2048
#define NIOS2_ICACHE_LINE_SIZE 32
#define NIOS2_DCACHE_LINE_SIZE 4

/*
 * ROMξΡROM(FLASH)RAM
 */ 
#define ROM_BASE   0x00000000
#define RAM_BASE   0x00000000

#ifndef TOPPERS_MACRO_ONLY
#endif /* TOPPERS_MACRO_ONLY */

#ifndef TOPPERS_MACRO_ONLY
#ifdef TOPPERS_GDB_STUB				/* GDB */
#else /* TOPPERS_GDB_STUB */		/* ¾γȯĶ */
#endif /* TOPPERS_GDB_STUB */
#endif /* TOPPERS_MACRO_ONLY */


#endif /* NIOS2_HAL */

#endif /* TOPPERS_FSMPB_H */
