/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  FSTOPPERS
 *  Copyright (C) 2008 by FUJISOFT INCORPORATED, JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_config.c,v 1.3 2008/05/26 09:06:19 myasuma Exp $
 */


#include "kernel_impl.h"
#include <sil.h>
#include "target_serial.h"


#ifdef NIOS2_HAL


//#include <system.h>
//#include <sys/alt_sys_init.h>
#include <stdlib.h>

#include "sys/alt_sys_init.h"
#include "priv/alt_file.h"

extern void _do_ctors(void);
extern void _do_dtors(void);

/*
 * HALؿΥС饤
 *
 * alt_irq_register()
 */
int
alt_irq_register(alt_u32 id, void* context, void (*handler)(void*, alt_u32))
{
    return (0);
}

/*
 *  ٥ΥåȰ¸νʥϡɥ
 */
int
hardware_init_hook()
{
    return (0);
}

/*
 *  ٥ΥåȰ¸νʥեȥ
 */
int
software_init_hook()
{
    return (0);
}

/*
 *  åȥƥ¸ 롼
 */
void
target_initialize()
{
    /*
     *  ޥե
     */
    ALT_SEM_CREATE (&alt_fd_list_lock, 1);

    /*
     *  HALǥХν
     */
    alt_sys_init();

    /*
     *  쥯I/O
     */
    alt_io_redirect(ALT_STDOUT, ALT_STDIN, ALT_STDERR);

    /*
     *  C++ݎĎ׎ƤӽФ
     *  C++ǥȥ饯Ͽ
     */
#ifndef ALT_NO_C_PLUS_PLUS
    _do_ctors ();
#endif /* ALT_NO_C_PLUS_PLUS */

#if !defined(ALT_NO_C_PLUS_PLUS) && !defined(ALT_NO_CLEAN_EXIT) && !defined(ALT_NO_EXIT)
    atexit (_do_dtors);
#endif

    /*
     *  ץå¸ν
     */
    prc_initialize();
}

#else  /* NIOS2_HAL */
/*
 *  åȥƥ¸ 롼
 */
void
target_initialize()
{
	/*
	 *  ץå¸ν
	 */
	prc_initialize();

}

#endif /* NIOS2_HAL */


/*
 *  åȥƥνλ롼
 *
 *  ƥλ˻Ȥ̾ϥ˥ƤӽФǼ¸롥
 *  
 */
void
target_exit(void)							/* (6-8-5) */
{
	/*
	 *  ץå¸νλ
	 */
	prc_terminate();

    Asm("break");
}

/*
 *  ƥ٥ϤΤʸϴؿ
 */
void
target_fput_log(char_t c)						/* (8-1-4) */
{
    if (c == '\n') {
        uart_putc('\r');
    }
    uart_putc(c);
}


#ifndef OMIT_DEFAULT_INT_HANDLER
/*
 * 6.4.6 ׵饤°
 *
 * °ꤵƤ뤳Ȥε(bitpat_cfgint)
 * CFG_INT°TA_ENAINTǤIRQͭ
 *
 * ͡
 *   NiosIIǤϡߥȥФƳ׵饤
 *   ʲϹԤʤᡢʤ
 *
 * å٥
 * IRQͥ (IRQֹ=ͥ٤ȤͤΤ)
 *
 */
void
x_config_int(INTNO intno, ATR intatr, PRI intpri)		/* (6-4-6-2) */
{
    uint32_t	i;
    uint32_t	ipm_idx;

    assert(VALID_INTNO(intno));
    assert(TMIN_INTPRI <= intpri && intpri <= TMAX_INTPRI);

    /*
     *  °ꤵƤ뤫Ƚ̤뤿ѿ
     */
    bitpat_cfgint |= INTNO_BITPAT(intno);
    
    if ((intatr & TA_ENAINT) != 0U){
        (void)x_enable_int(intno);		/* ߶ػ߲ */
    } else if ((intatr & TA_ENAINT) == 0U) {
        (void)x_disable_int(intno);		/* ߶ػߤ */
	}
	
	/*
	 *  ͥ٥ơ֥
	 *  Ϥ줿ͥ٤ǳֹϿϿ򥫥ȥåס
	 */
	ipm_idx = INDEX_IPM(intpri) - INDEX_IPM(TMAX_INTPRI);
	inh_ipm_tbl[ipm_idx].intno[inh_ipm_tbl[ipm_idx].num] = intno;
	inh_ipm_tbl[ipm_idx].num++;
	
	/*
	 *  ͥ٥ޥơ֥
	 */
	if (INDEX_IPM(intpri) != INDEX_IPM(TMAX_INTPRI)) {
		/* ꤵ줿ͥ٤ꡢĲͥ٤˥ӥåȤ */
		ipm_mask_tbl[ipm_idx] |= (1 << intno);
	}

	/* ͥ٥ޥΥޡ */
	for (i = (IPM_MASK_TBL_MAX - 1); i > INDEX_IPM(TMAX_INTPRI); i--) {
		ipm_mask_tbl[i - 1] |= ipm_mask_tbl[i];
	}

}
#endif /* OMIT_DEFAULT_INT_HANDLER */
