/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  FSTOPPERS
 *  Copyright (C) 2008 by FUJISOFT INCORPORATED, JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_config.h,v 1.2 2008/05/26 09:06:19 myasuma Exp $
 */

/*
 *		åȰ¸⥸塼FSMPB for NiosIIѡ
 *
 *  ͥΥåȰ¸Υ󥯥롼ɥե롥kernel_impl.hΥ
 *  åȰ¸ΰդȤʤ롥
 */

#ifndef TOPPERS_TARGET_CONFIG_H
#define TOPPERS_TARGET_CONFIG_H

/*
 *  åȥƥΥϡɥ񸻤
 */
#include "fsmpb.h"

/*
 *  ȥ졼˴ؤ
 */
#include "logtrace/trace_config.h"

/*
 *   åΰ
 */                 
#ifndef NIOS2_HAL
#define STACKTOP    0x01000000				/* Ωѥåν */
#endif	/* NIOS2_HAL */


/*
 *  6.10.1 󥿥ƥѤΥåΰ
 */
#define DEFAULT_ISTKSZ		0x2000U							/* (6-10-1-1) */

#ifndef NIOS2_HAL
#define DEFAULT_ISTK		(void *)(STACKTOP - DEFAULT_ISTKSZ)
															/* (6-10-1-2) */
#endif	/* NIOS2_HAL */

/*
 *  󥿥ƥѤΥå                     (6-10-1-3)
 */
#define TOPPERS_ISTKPT(istk, istksz) ((STK_T *)((char *)(istk) + (istksz)))


/*
 *  ߥϥɥֹ˴ؤ
 */ 
#define TMIN_INHNO 0U
#define TMAX_INHNO 31U
#define TNUM_INH   32U

/*
 *  ֹ˴ؤ
 */ 
#define TMIN_INTNO 0U
#define TMAX_INTNO 31U
#define TNUM_INT   32U

#ifndef TOPPERS_MACRO_ONLY

/*
 *  ֹϰϤȽ
 */
#define VALID_INTNO(intno) (TMIN_INTNO <= (intno) && (intno) <= TMAX_INTNO)
#define VALID_INTNO_DISINT(intno)	VALID_INTNO(intno)		/* (6-4-2-1) */
#define VALID_INTNO_CFGINT(intno)	VALID_INTNO(intno)		/* (6-4-6-1) */
#define VALID_INTNO_ATTISR(intno)   VALID_INTNO(intno)

#endif /* TOPPERS_MACRO_ONLY */  

/*
 *  ͥ̾Υ͡
 */
#ifndef OMIT_RENAME

#ifdef LABEL_ASM

#endif /* LABEL_ASM */
#endif /* OMIT_RENAME */

#ifndef TOPPERS_MACRO_ONLY


#ifdef NIOS2_HAL
#include "alt_types.h"
/*
 *  HAL ؿΥС饤
 *
 *  alt_irq_register()
 */
extern int alt_irq_register (alt_u32 id, 
                             void*   context, 
                             void (*irq_handler)(void*, alt_u32));
/*
 *  ٥ΥåȰ¸νʥϡɥ
 */
extern int hardware_init_hook();

/*
 *  ٥ΥåȰ¸νʥեȥ
 */
extern int software_init_hook();

#endif /* NIOS2_HAL */


/*
 *  åȥƥ¸ν
 */
extern void	target_initialize(void);	/* (6-8-2) */

/*
 *  åȥƥνλ
 *
 *  ƥλ˻ȤROM˥ƽФǼ¸뤳Ȥꤷ
 *  Ƥ롥
 */
extern void	target_exit(void);

#endif /* TOPPERS_MACRO_ONLY */

/*
 *  ԤΤ
 */
#define SIL_DLY_TIM1    420				/* (4-2-2) */
#define SIL_DLY_TIM2    90				/* (4-2-3) */

/*
 *  ץå¸⥸塼NiosIIѡ
 */
#include "nios2_gcc/prc_config.h"

#endif /* TOPPERS_TARGET_CONFIG_H */
