/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  FSTOPPERS
 *  Copyright (C) 2008 by FUJISOFT INCORPORATED, JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_timer.h,v 1.3 2008/05/26 09:06:21 myasuma Exp $
 */

/*
 *  ޥɥ饤СFSMPB for NiosIIѡ
 */

#ifndef TOPPERS_TARGET_TIMER_H
#define TOPPERS_TARGET_TIMER_H

#include "target_kernel.h"

#ifdef NIOS2_HAL

#ifndef TOPPERS_MACRO_ONLY
#include "system.h"
#include "altera_avalon_timer/inc/altera_avalon_timer_regs.h"
#endif /* TOPPERS_MACRO_ONLY */

#endif /* NIOS2_HAL */


/*
 * ޳ߥϥɥγֹ
 */
#define INHNO_TIMER     TIM_INTLVL      /* ߥϥɥֹ */
#define INTNO_TIMER     TIM_INTLVL      /* ֹ */
#define INTPRI_TIMER    TIM_INTLVL      /* ͥ */
#define INTATR_TIMER    TA_EDGE         /* ° */

/*
 *  ޡå
 *
 *  NiosIIΥޥΥ󥿤ͥ0x00000000ˤ1å
 *  ʤƤΤǡͤ-1ͤȤƤʤ1ĹʤäƤޤ
 *  (ALTERA Avalon󥿥եб ޡ)
 *
 *  <׻>
 *   ƥ९å޼ȿ  1000  (Tickʬ  Tickʬ)  1 
 *
 *  [㡧CPUå40MHzǥޥ10msꤹ]
 *   40,000,000  1000  (10  1)  1 = 399,999 (0x61a7f)
 *
 *  [㡧CPUå60MHzǥޥ10msꤹ]
 *   60,000,000  1000  (10  1)  1 = 599,999 (0x927bf)
 *
 */
#ifdef NIOS2_HAL

#define TIMER_CLOCK     ((SYS_CLK_TIMER_FREQ / 1000 * (TIC_NUME / TIC_DENO)) - 1)

#else  /* NIOS2_HAL */
/*
 * []
 *  ܡΥƥ९å޼ȿꤹ뤳ȡ
 */
#define TIMER_CLOCK     ((40000000 / 1000 * (TIC_NUME / TIC_DENO)) - 1)

#endif /* NIOS2_HAL */

/*
 * ͤɽη
 */
typedef uint32_t CLOCK;

/*
 *  ͤɽäѴ
 */
#define TO_USEC(clock)      ((clock) * 1000 / (TIMER_CLOCK / (TIC_NUME / TIC_DENO)))

/*
 *  Ǥ祿޼ñ̤ɽ
 */
#define MAX_CLOCK ((CLOCK) 0xffffffff)


#ifndef TOPPERS_MACRO_ONLY

/*
 * 6.13 ޥɥ饤
 */

/*
 * ޤν (6-13-2-1)
 */
#define target_timer_initialize     nios2_timer_initialize
extern void nios2_timer_initialize(intptr_t exinf);

/*
 *   ޤνλ (6-13-2-2)
 */
#define target_timer_terminate      nios2_timer_terminate
extern void nios2_timer_terminate(intptr_t exinf);

/*
 *   ޳׵Υꥢ
 */
#define target_timer_int_clear      nios2_timer_int_clear
extern void nios2_timer_int_clear();

/*
 *   ߤȯƤ뤫Ƚ (6-13-3-3)
 */
#define target_timer_probe_int      nios2_timer_fetch_interrupt
extern bool_t nios2_timer_fetch_interrupt(void);

/*
 *   ޤθͤɤ߽Ф (6-13-3-2)
 */
#define target_timer_get_current    nios2_timer_get_current
extern CLOCK nios2_timer_get_current(void);

/*
 *  ޳ߥϥɥ (6-13-2-3)
 */
extern void	target_timer_handler(void);

#endif  /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_TARGET_TIMER_H */
